package ornek;

import java.util.List;

import tr.gov.tubitak.uekae.esya.api.asn.x509.ECertificate;
import tr.gov.tubitak.uekae.esya.api.common.crypto.BaseSigner;
import tr.gov.tubitak.uekae.esya.api.common.util.bag.Pair;
import tr.gov.tubitak.uekae.esya.api.crypto.alg.SignatureAlg;
import tr.gov.tubitak.uekae.esya.api.smartcard.pkcs11.CardType;
import tr.gov.tubitak.uekae.esya.api.smartcard.pkcs11.SmartCard;
import tr.gov.tubitak.uekae.esya.api.smartcard.pkcs11.SmartOp;
import tr.gov.tubitak.uekae.esya.api.smartcard.util.SCSignerWithCertSerialNo;

public class SmartCardDetectSample {

	
	
	public static void main(String[] args) throws Exception  {
		
		Pair<Long, CardType> cardTypeAndSlot = 	SmartOp.findCardTypeAndSlot();
		long slot = cardTypeAndSlot.getObject1();
		CardType cardType = cardTypeAndSlot.getObject2();
		SmartCard smartCard = new SmartCard(cardType);
		long session = smartCard.openSession(slot);  
		smartCard.login(session,"123456");	
		
		
		List<byte[]> signatureCertificates = smartCard.getSignatureCertificates(session);
		ECertificate signingCert = new ECertificate(signatureCertificates.get(0));
		
		System.out.println(signingCert);
		
		//Signer Oluşturma
		BaseSigner signer = new SCSignerWithCertSerialNo(smartCard, session, slot, 
						signingCert.getSerialNumber().toByteArray(), 
						SignatureAlg.RSA_SHA256.getName());
		
	}
}
